const names = require('./names.js');

const UnicodeTrie = require('unicode-trie')
const fs = require('fs')

const propIdToNames = {};
for (const propName in names.props) {
  const propId = names.props[propName];
  if (!propIdToNames[propId]) propIdToNames[propId] = propIdToNames[propId] || [];
  propIdToNames[propId].push(propName);
}

exports.propId = function(name) {
  return names.props[name];
};

exports.propIdToNames = function(propId) {
  return propIdToNames[propId];
};

exports.propValues = function(propId) {
  return names.propValues[propId];
};

exports.regex = function(propId) {
  return names.regexes[propId];
};

exports.propIdsWithRegexes = function() {
  return Object.keys(names.regexes);
};


function loadFile(prop) {
  if (prop === 'BidiClass') return fs.readFileSync(__dirname + '/' + 'BidiClass' + '.trie');
  if (prop === 'NumericType') return fs.readFileSync(__dirname + '/' + 'NumericType' + '.trie');
  if (prop === 'NumericValue') return fs.readFileSync(__dirname + '/' + 'NumericValue' + '.trie');
}

exports.propTrie = function(prop) {
  return new UnicodeTrie(loadFile(prop));
};

